var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.PIPES=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));

var _chalk=_interopRequireDefault(require("chalk"));
var _inquirer=_interopRequireDefault(require("inquirer"));
var _ora=_interopRequireDefault(require("ora"));
var _constants=require("../constants");
var _common=require("../common");



var _buildHooks=require("../projectTools/buildHooks");
var _fileutils=require("../systemTools/fileutils");

var LIST='list';
var ADD='add';
var UPDATE='update';

var PIPES={
PLUGIN_LIST_BEFORE:'plugin:list:before',
PLUGIN_LIST_AFTER:'plugin:list:after',
PLUGIN_ADD_BEFORE:'plugin:add:before',
PLUGIN_ADD_AFTER:'plugin:add:after',
PLUGIN_UPDATE_BEFORE:'plugin:update:before',
PLUGIN_UPDATE_AFTER:'plugin:update:after'};exports.PIPES=PIPES;






var run=function run(c){
(0,_common.logTask)('run');

switch(c.subCommand){
case LIST:
return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_LIST_BEFORE).
then(function(){return _runList(c);}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_LIST_AFTER);});
case ADD:
return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_ADD_BEFORE).
then(function(){return _runAdd(c);}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_ADD_AFTER);});
case UPDATE:
return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_UPDATE_BEFORE).
then(function(){return _runUpdate(c);}).
then(function(){return(0,_buildHooks.executePipe)(c,PIPES.PLUGIN_UPDATE_AFTER);});
default:
return Promise.reject("cli:plugin: Sub-Command "+_chalk.default.white.bold(c.subCommand)+" not supported!");}

};





var _runList=function _runList(c){return new Promise(function(resolve){
(0,_common.logTask)('_runList');

var o=_getPluginList(c);

console.log(o.asString);

resolve();
});};

var _getPluginList=function _getPluginList(c){var isUpdate=arguments.length>1&&arguments[1]!==undefined?arguments[1]:false;var
plugins=c.files.rnv.pluginTemplates.config.plugins;
var output={
asString:'',
asArray:[],
plugins:[],
json:plugins};


var i=1;

Object.keys(plugins).forEach(function(k){
var p=plugins[k];

var platforms='';
_constants.SUPPORTED_PLATFORMS.forEach(function(v){
if(p[v])platforms+=v+", ";
});
if(platforms.length)platforms=platforms.slice(0,platforms.length-2);
var installedPlugin=c.buildConfig&&c.buildConfig.plugins&&c.buildConfig.plugins[k];
var installedString=installedPlugin?_chalk.default.red('installed'):_chalk.default.green('not installed');
if(isUpdate&&installedPlugin){
output.plugins.push(k);
var versionString;
if(installedPlugin.version!==p.version){
versionString="("+_chalk.default.red(installedPlugin.version)+") => ("+_chalk.default.green(p.version)+")";
}else{
versionString="("+_chalk.default.green(installedPlugin.version)+")";
}
output.asString+="-["+i+"] "+_chalk.default.white(k)+" "+versionString+"\n";
output.asArray.push({name:k+" "+versionString,value:k});
i++;
}else if(!isUpdate){
output.plugins.push(k);
output.asString+="-["+i+"] "+_chalk.default.white(k)+" ("+_chalk.default.blue(p.version)+") ["+platforms+"] - "+installedString+"\n";
output.asArray.push({name:k+" ("+_chalk.default.blue(p.version)+") ["+platforms+"] - "+installedString,value:k});

i++;
}
output.asArray.sort(function(a,b){
var aStr=a.name.toLowerCase();
var bStr=b.name.toLowerCase();
var com=0;
if(aStr>bStr){
com=1;
}else if(aStr<bStr){
com=-1;
}
return com;
});
});

return output;
};

var _runAdd=function _runAdd(c){var o,_ref,plugins,installMessage,selectedPlugins,spinner;return _regenerator.default.async(function _runAdd$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_common.logTask)('_runAdd');

o=_getPluginList(c);_context.next=4;return _regenerator.default.awrap(

_inquirer.default.prompt({
name:'plugins',
type:'rawlist',
message:'Select the plugins you want to add',
choices:o.asArray,
pageSize:100}));case 4:_ref=_context.sent;plugins=_ref.plugins;


installMessage=[];

if(plugins.length){
selectedPlugins={};
plugins.forEach(function(plugin){
selectedPlugins[plugin]=o.json[plugin];
installMessage.push(_chalk.default.white(plugin)+" v("+_chalk.default.green(o.json[plugin].version)+")");
});

spinner=(0,_ora.default)("Installing: "+installMessage.join(', ')).start();

Object.keys(selectedPlugins).forEach(function(key){

c.files.project.config.plugins[key]='source:rnv';


_checkAndAddDependantPlugins(c,selectedPlugins[key]);
});

(0,_fileutils.writeObjectSync)(c.paths.project.config,c.files.project.config);
spinner.succeed('All plugins installed!');
(0,_common.logSuccess)('Plugins installed successfully!');
}case 8:case"end":return _context.stop();}}});};


var _checkAndAddDependantPlugins=function _checkAndAddDependantPlugins(c,plugin){
var templatePlugins=c.files.rnv.pluginTemplates.config.plugins;
if(plugin.dependsOn){
plugin.dependsOn.forEach(function(v){
if(templatePlugins[v]){
console.log("Added dependant plugin "+v);
c.buildConfig.plugins[v]=templatePlugins[v];
}
});
}
};

var _runUpdate=function _runUpdate(c){var o,_ref2,confirm,plugins;return _regenerator.default.async(function _runUpdate$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_common.logTask)('_runUpdate');

o=_getPluginList(c,true);

console.log(o.asString);_context2.next=5;return _regenerator.default.awrap(

_inquirer.default.prompt({
name:'confirm',
type:'confirm',
message:'Above installed plugins will be updated with RNV'}));case 5:_ref2=_context2.sent;confirm=_ref2.confirm;


if(confirm){
plugins=c.buildConfig.plugins;
Object.keys(plugins).forEach(function(key){

c.files.project.config.plugins[key]=o.json[key];
});

(0,_fileutils.writeObjectSync)(c.paths.project.config,c.files.project.config);

(0,_common.logSuccess)('Plugins updated successfully!');
}case 8:case"end":return _context2.stop();}}});};var _default=




run;exports.default=_default;
//# sourceMappingURL=plugin.js.map